function fxDtsBrick::burnLoop(%brick, %last)
{
	cancel(%brick.burnLoop);
	if(%brick.burnedFuel == 0)
		%brick.setEmitter(BurnEmitterB);
	%data = %brick.getDatablock();
	%volume = %data.brickSizeX * %data.brickSizeY * %data.brickSizeZ;
	%time = vectorDist(%last, %now = getSimTime()) / 1000;
	%brick.burnedFuel += %time;
	if(%brick.material !$= "Charcoal" && %brick.burnedFuel >= (mSqrt(%volume) / 10) * 9)
	{
		%brick.dontRefund = 1;
		%brick.isIgnitable = 1;
		%brick.unrecolorable = 0;
		%brick.setColor($EOTW::Colors::Charcoal);
		%brick.material = "Charcoal";
		%brick.unrecolorable = 1;
	}
	if(%brick.burnedFuel >= mSqrt(%volume))
	{
		%brick.dontRefund = 1;
		//if(%brick.material $= "Dead_Plant")
		//	%brick.trulyDont = 1;
		%brick.killBrick();
		return;
	}
	if(mAbs(%brick.angleID - 2) == 1)
	{
		%sizeX = %data.brickSizeY / 2;
		%sizeY = %data.brickSizeX / 2;
	}
	else
	{
		%sizeX = %data.brickSizeX / 2;
		%sizeY = %data.brickSizeY / 2;
	}
	%sizeZ = %data.brickSizeZ / 5;
	%box = vectorAdd(%sizeX SPC %sizeY SPC %sizeZ, "0.05 0.05 0.05");
	initContainerBoxSearch(%brick.getPosition(), %box, $Typemasks::fxBrickAlwaysObjectType);
	while(isObject(%test = containerSearchNext()))
		if(%test != %brick && !isEventPending(%test.burnLoop) && %test.isFlammable)
		{
			%testDB = %test.getDatablock();
			%testVol = %testDB.brickSizeX * %testDB.brickSizeY * %testDB.brickSizeZ;
			%sizeDiff = %testVol / %volume; %ignite = !getRandom(0, mFloor(%sizeDiff * 80) + 20);
			if(%ignite) %test.burnLoop(getSimTime());
		}
	if($EOTW::SaveData::Day >= 38)
	{
		%mask = $Typemasks::fxBrickObjectType;
		initContainerBoxSearch(%pos = %brick.getPosition(), %box, $Typemasks::PlayerObjectType);
		while(isObject(%player = containerSearchNext()))
		{
			if(!isObject(containerRaycast(%pos, %player.getHackPosition(), %mask)))
			{
				%player.burningTime += 0.02;
				if(!isEventPending(%player.burnLoop))
					%player.burnLoop(getSimTime());
			}
		}
	}
	%brick.burnLoop = %brick.schedule(48, "burnLoop", %now);
}

function Player::burnLoop(%player, %last)
{
	cancel(%player.burnLoop);
	if(!isObject(%player) || %player.getState() $= "DEAD") return;
	if(!isEventPending(%player.EOTW_FireTrail))
		%player.EOTW_FireTrail();
	%mask = $Typemasks::fxBrickObjectType;
	initContainerRadiusSearch(%pos = %player.getHackPosition(), 10, $Typemasks::PlayerObjectType);
	while(isObject(%this = containerSearchNext()))
		if(vectorDist(%pos, %loc = %this.getHackPosition()) <= 4 && !isObject(containerRaycast(%pos, %loc, %mask)) && !%this.immuneToFire)
		{ %sum += %this.burningTime; %obj[-1+%objs++] = %this; } %avg = %sum / %objs;
	if(%objs > 1 && %avg > 0.05) for(%i=0;%i<%objs;%i++) { %obj[%i].burningTime = %avg; if(!isEventPending(%obj[%i].burnLoop)) %obj[%i].schedule(16, "burnLoop", getSimTime()); }
	%time = vectorDist(%last, %now = getSimTime()) / 1000;
	if(%time > %player.burningTime)
	{
		%dmg = %player.burningTime * 5;
		%player.burningTime = 0;
	}
	else
	{
		%dmg = %time * 5;
		%player.burningTime -= %time;
	}
	if(!%player.immuneToBurn)
	{
		if(%player.getDamageLevel() + %dmg >= %player.getDatablock().maxDamage)
			%player.damage(0, 0, 10000, $DamageType::BurnedToDeath);
		else
		{
			%player.setDamageLevel(%player.getDamageLevel() + %dmg);
			%player.setDamageFlash(0.25);
		//	%flash = getMin(%player.getDamageFlash() + %dmg / 5, 0.75);
		//	%player.setDamageFlash(%flash);
		}
	}
	if(%player.burningTime == 0) { cancel(%player.EOTW_FireTrail); return; }
	%player.burnLoop = %player.schedule(16, "burnLoop", %now);
}

function Player::EOTW_FireTrail(%player)
{
	cancel(%player.EOTW_FireTrail);
	if(!isObject(%player) || %player.getState() $= "DEAD") return;
	%flame = new ParticleEmitterNode()
	{
		datablock = GenericEmitterNode;
		emitter = BurnEmitterA;
		position = %player.position;
	};
	%flame.delete = %flame.schedule(500, "delete");
	%player.EOTW_FireTrail = %player.schedule(100, "EOTW_FireTrail");
}