if(!$EOTW::hasBeenLoaded)
{
	AddDamageType("BurnedToDeath", '%1 burned to death!', '%1 burned to death!', 1, 1);
	AddDamageType("EOTWFireball", '%1 was hit by a meteor!', '%1 was hit by a meteor!', 1, 1);
	AddDamageType("Sun", '%1 got fried by the Sun!', '%1 got fried by the Sun!', 1, 1);
	//AddDamageType("BurnedToDeath", '', '', 1, 1);
	//AddDamageType("EOTWFireball", '', '', 1, 1);
	//AddDamageType("Sun", '', '', 1, 1);
}

datablock fxDTSBrickData(brickSolarApocRocketData)
{
	brickFile = "./shapes/Rocket.blb";
	category = "Special";
	subCategory = "Solar Apoc";
	uiName = "Rocket";
	iconName = "";
};

PlayerNoJet.maxTools = 7;
PlayerNoJet.maxWeapons = 7;

function servercmdHelp(%client)
{
	%client.chatMessage("\c6Commands:");
	%client.chatMessage("\c6 - \c3/give [amount] [material] to [name] \c6- Gives materials to other players. Use \"BL_ID [numbers]\" as the name to specify a BL_ID");
	%client.chatMessage("\c6 - \c3/craft [object] \c6- Crafts something using materials. Leave the object blank for a list of craftable stuff.");
	%client.chatMessage("\c6 - \c3/research [goal] \c6- Researches something to unlock new recipes or abilities. Leave the goal blank for a list of researchable stuff.");
	%client.chatMessage("\c6The goal of Solar Apocalypse is to survive the deadly sun's heat by building bases.");
	%client.chatMessage("\c6Better materials help you survive longer.");
}

function servercmdCommands(%client)
{
	servercmdHelp(%client);
}

if(isPackage(EOTW))
	deactivatePackage(EOTW);
package EOTW
{
	function GameConnection::AutoAdminCheck(%client)
	{
		Parent::AutoAdminCheck(%client);
		%client.material = "Wood";
		
		if($EOTW::PlayerData[%client.bl_id, "CurrentTool"] $= "")
			$EOTW::PlayerData[%client.bl_id, "CurrentTool"] = "solarApocToolHandsImage";
		if($EOTW::PlayerData[%client.bl_id, "CurrentPill"] $= "")
			$EOTW::PlayerData[%client.bl_id, "CurrentPill"] = "solarApocEmptyItem";
		
		//decided to remove loading saves. it didn't feel right
		//load their save when they join
		//if(isFile("config/server/SolarApoc/playersaves/" @ %client.bl_id @ ".cs"))
		//	exec("config/server/SolarApoc/playersaves/" @ %client.bl_id @ ".cs");
		
		export("$EOTW::PlayerData" @ %client.bl_id @ "_*", "config/server/SolarApoc/playersaves/" @ %client.bl_id @ ".cs");
	}
	
	function fxDtsBrick::setColor(%brick, %color)
	{
		if(!%brick.unrecolorable && (getWord(getColorIDTable(%color), 3) > 0.95 || (%brick.material $= "Glass" || %brick.material $= "")))
			Parent::setColor(%brick, %color);
	}
	
	function servercmdEnvGui_SetVar(%client, %var, %arg)
	{
		if(!%client.environMaster)
		{
			if(!$EnvGuiTesting)
			{
				%client.centerPrint("<color:FF8000>You cannot edit these settings.", 15);
				return;
			}
			else
				echo(%var SPC %arg);
		}
		Parent::servercmdEnvGui_SetVar(%client, %var, %arg);
	}
	
	function ServerCmdPlantBrick(%client)
	{
		//player check
		%player = %client.player;
		if(!isObject(%player))
		{
			parent::ServerCmdPlantBrick(%client);
			return;
		}
		
		//temp brick check
		%temp = %player.tempBrick;
		if(!isObject(%temp))
		{
			parent::ServerCmdPlantBrick(%client);
			return;
		}
		
		%data = %temp.getDatablock();
		
		%pos = %temp.getPosition();
		%posZ = getWord(%pos, 2);
		%bottom = %posZ - (%data.bricksizez * 0.1);
		
		%volume = %data.brickSizeX * %data.brickSizeY * %data.brickSizeZ;
		
		//blocked bricks check
		if(firstWord(%data.uiName) $= "Coffin" || %data.subCategory $= "Water" || firstWord(%data.uiName) $= "Rocket")
		{
			%client.centerPrint("<color:FF0000>Whoops!<br>\c6You can't place that brick!", 3);
			return;
		}
		
		//on ground check
		if(mfloor(%bottom * 10) >= -1 && mfloor(%bottom * 10) <= 1)
		{
			//size check
			if(%volume < 3)
			{
				%client.centerPrint("<color:FF0000>Whoops!<br>\c6That brick is too small to be placed on the ground!", 3);
				return;
			}
		}
		
		//plant check
		%material = %client.material;
		if(isPlant(%material) && %data.getName() !$= "brick1x1FData")
		{
			%client.centerPrint("<color:FF0000>Whoops!<br>\c6Plants must be a 1x1F brick.", 3);
			return;
		}
		
		//volume check
		if($EOTW::PlayerData[%client.bl_id, "Material", %material] >= %volume || %client.materialDebug)
		{
			//it passed all the checks
			%precount = %client.brickGroup.getCount();
			parent::ServerCmdPlantBrick(%client);
			%postcount = %client.brickGroup.getCount();
			
			//only charge them if the brick was placed correctly
			if(%precount < %postcount) //this is to prevent having them lose material if trust doesnt match or if they were somehow unable to place the brick
			{
				%brick = %client.brickGroup.getObject(%postcount - 1); //temp brick seems to count as a brick
				if(!isObject(%brick))
					return error("ERROR: brick somehow doesnt exist");
				
				//place brick with material stuff
				%client.addMaterial(%volume * -1, %material, "\c7to build a brick");
				%brick.material = %material;
				%brick.setColor($EOTW::Colors["::" @ (%material $= "Dead_Plant" ? "Dead": %material)]);
				switch$(%material)
				{
					case "Dead_Plant":
						%brick.canBeFireballed = 1;
						%brick.isBreakable = 1;
						%brick.isFlammable = 1;
						%brick.isIgnitable = 1;
						%brick.unrecolorable = 1;
						%brick.setColliding(0);
						%brick.burnLoop(getSimTime());
						%client.centerPrint("<color:FFFFFF>Well done, Sally Mc Smarty Pants. You found a way to build Dead Plant.", 3);
					case "Charcoal":
						%brick.canBeFireballed = 1;
						%brick.isBreakable = 1;
						%brick.isFlammable = 1;
						%brick.isIgnitable = 1;
						%brick.unrecolorable = 1;
						%brick.burnLoop(getSimTime());
						%client.centerPrint("<color:FFFFFF>Well done, Sally Mc Smarty Pants. You found a way to build Charcoal.", 3);
					case "Glass":
						%brick.canBeFireballed = 1;
						%brick.isBreakable = 1;
						%brick.smashable = 1;
					case "Grass":
						%brick.canBeFireballed = 1;
						%brick.isBreakable = 1;
						%brick.isFlammable = 1;
						%brick.unrecolorable = 1;
						%brick.setColliding(0);
						%brick.schedule(48, "EOTW_GrowGrass", 0, 0, 0, getSimTime());
						%client.centerPrint("<color:FFFFFF>Well done, Sally Mc Smarty Pants. You found a way to build Grass.", 3);
					case "Metal":
						%brick.isBreakable = 1;
					case "Stone":
						%brick.canBeFireballed = 1;
						%brick.isBreakable = 1;
					case "Vine":
						%brick.canBeFireballed = 1;
						%brick.isBreakable = 1;
						%brick.isFlammable = 1;
						%brick.unrecolorable = 1;
						%brick.setColliding(0);
						%brick.schedule(48, "EOTW_GrowVine", 0, 0, 0, getSimTime());
					case "Wood":
						%brick.canBeFireballed = 1;
						%brick.isBreakable = 1;
						%brick.isFlammable = 1;
						%brick.isIgnitable = 1;
				}
				%client.showEOTWHud();
			}
		}
		else
			%client.centerPrint("<color:FF0000>Whoops!<br>\c6You don't have enough " @ getMaterialName(%material) @ " to place that brick!", 3);
	}
	
	function servercmdSetWrenchData(%client, %data)
	{
		if(isEventPending($EnvMasterLoop))
		{
			%item = getWord(getField(%data, 4), 1);
			%allowedItem[-1+%allowedItems++] = "Key Blue";
			%allowedItem[-1+%allowedItems++] = "Key Green";
			%allowedItem[-1+%allowedItems++] = "Key Red";
			%allowedItem[-1+%allowedItems++] = "Key Yellow";
			%allowedItem[-1+%allowedItems++] = "Push Broom";
			%allowedItem[-1+%allowedItems++] = "Ball Basketball";
			%allowedItem[-1+%allowedItems++] = "Ball Football";
			%allowedItem[-1+%allowedItems++] = "Ball Soccer Ball";
			%allowedItem[-1+%allowedItems++] = "Ball Dodgeball";
			%allowedItem[-1+%allowedItems++] = "Skis";
			for(%i=0;%i<%allowedItems;%i++)
			{
				if(%item.uiName $= %allowedItem[%i])
					%allow = 1;
			}
			if(!%allow)
				%data = setField(%data, 4, "IDB 0");	//People shoot projectiles at others.
		}
		Parent::servercmdSetWrenchData(%client, %data);
	}
	
	function fxDtsBrick::onDeath(%brick)
	{
		if(!%brick.dontRefund)
		{
			%data = %brick.getDatablock();
			%volume = %data.brickSizeX * %data.brickSizeY * %data.brickSizeZ;
			%blid = %brick.getGroup().bl_id;
			%client = findclientbybl_id(%blid);
			if(isObject(%client))
			{
				if(%brick.material !$= "")
					%client.addMaterial(%volume, %brick.material, "\c7from broken brick");
			}
		}
		%brick.wasBroken = true;
		Parent::onDeath(%brick);
	}
	
	function fxDtsBrick::onRemove(%brick)
	{
		if(!%brick.wasBroken && !%brick.dontRefund)
		{
			%data = %brick.getDatablock();
			%volume = %data.brickSizeX * %data.brickSizeY * %data.brickSizeZ;
			%blid = %brick.getGroup().bl_id;
			%client = findclientbybl_id(%blid);
			if(isObject(%client))
			{
				if(%brick.material !$= "")
					%client.addMaterial(%volume, %brick.material, "\c7from broken brick");
			}
		}
		Parent::onDeath(%brick);
	}
	
	function GameConnection::createPlayer(%client, %trans)
	{
		if($EOTW::SaveData::Day >= 10 && $EOTW::IsDay)
		{
			if(%client.HasDied || !%client.hasSpawnedOnce)
			{
				if(isObject(%client.getControlObject()))
				{
					if(%client.HasDied)
						%client.chatMessage("\c5You have died. Please wait for the sun to set.");
					else if(!%client.hasSpawnedOnce)
						%client.chatMessage("\c5You joined the server during the day. Please wait for the sun to set.");
				}
				
				if(!isObject(%client.getControlObject()))
				{
					%cam = %client.camera;
					%cam.setTransform(%trans);
					%client.setControlObject(%cam);
				}
				return;
			}
		}
		Parent::createPlayer(%client, %trans);
		if($EOTW::PlayerData[%client.bl_id, "CurrentTool"] $= "")
			$EOTW::PlayerData[%client.bl_id, "CurrentTool"] = "solarApocToolHandsImage";
		if($EOTW::PlayerData[%client.bl_id, "CurrentPill"] $= "")
			$EOTW::PlayerData[%client.bl_id, "CurrentPill"] = "solarApocEmptyItem";
		// if(isEventPending($EnvMasterLoop) && isObject(%player = %client.player))
		// {
			// %player.setShapeNameDistance(0);
			// %player.setDatablock(PlayerNoJet);
			// %player.clearTools();
			// %tool[-1+%tools++] = HammerItem.getID();
			// if(%client.isSuperAdmin || $Pref::EOTW::AllowWrench) %tool[-1+%tools++] = WrenchItem.getID();
			// %tool[-1+%tools++] = PrintGun.getID();
			// for(%i=0;%i<%tools;%i++)
			// {
				// %player.tool[%i] = %tool[%i];
				// messageClient(%client, 'MsgItemPickup', '', %i, %tool[%i], 1);
			// }
		// }
	}
	
	function GameConnection::onDeath(%client, %a, %b, %damageType, %d)
	{
		Parent::onDeath(%client, %a, %b, %damageType, %d);
		//if(%damageType == $DamageType::BurnedToDeath)
		//	messageClient(%client, '', "\c0"@%client.name@" burned to death!");
		//else if(%damageType == $DamageType::EOTWFireball)
		//	messageClient(%client, '', "\c0"@%client.name@" was hit by a meteor!");
		//else if(%damageType == $DamageType::Sun)
		//	messageClient(%client, '', "\c0"@%client.name@" got fried by the Sun!");
		if($EOTW::SaveData::Day >= 10 && $EOTW::IsDay)
			%client.HasDied = true;
	}
	
	function servercmdCreateMinigame(%client, %a, %b, %c, %d, %e, %f, %g, %h, %i, %j)
	{
		if(!isEventPending($EnvMasterLoop))
			Parent::servercmdCreateMinigame(%client, %a, %b, %c, %d, %e, %f, %g, %h, %i, %j);
	}
	
	//disable persistence stuff
	function GameConnection::savePersistence(%client)
	{
		return;
	}
	
	function GameConnection::loadPersistence(%client)
	{
		return;
	}
	
	function GameConnection::applyPersistence(%client, %gotPlayer, %gotCamera)
	{
		return;
	}
};
activatePackage("EOTW");

function EnvMasterLoop(%time, %day, %color, %colInc, %colTarg, %size)
{
	cancel($EnvMasterLoop);
	if($Overloaded)
	{
		$EnvMasterLoop = schedule((100 * ($SampleRate + 1)), 0, "EnvMasterLoop", %time, %day, %color, %colInc, %colTarg, %size);
		return;
	}
	
	if($EOTW::SaveData::Day <= 0)
		$EOTW::SaveData::Day = 1;
	if($EOTW::SaveData::Time < 0)
		$EOTW::SaveData::Time = 0;
	
	%day = $EOTW::SaveData::Day;
	%time = $EOTW::SaveData::Time;
	
	%time += $TimeSync;
	$TimeSync = 0;
	if(%time >= 360)
	{
		$hasHitSunsetOnce = false;
		%time = 0;
		%day++;
		if(isObject(BrickGroup_888888))
		{
			for(%i=0;%i<BrickGroup_888888.getCount();%i++)
			{
				if((%brick = BrickGroup_888888.getObject(%i)).destroyOnDay <= %day)
					%brick.killBrick();
			}
		}
		%size += 0.1;
		if(%size > 5)
			%size = 5;
		if(%day == 43) //if(%day == 53)
		{
			$EOTW::SaveData::SturdiumName = getSturdiumName();
			solarApocToolSturdiumImage.displayName = $EOTW::SaveData::SturdiumName @ " Pick";
			solarApocToolSturdiumItem.uiName = $EOTW::SaveData::SturdiumName @ " Pick";
		}
		if(%day >= 51) //if(%day >= 61) //shouldn't happen, but just in case
		{
			$EOTW::SaveData::Day = "";
			$EOTW::SaveData::Time = "";
			$EOTW::SaveData::SturdiumName = "???";
			
			%groups = MainBrickgroup.getCount();
			for(%i=0;%i<%groups;%i++)
			{
				%group = MainBrickgroup.getObject(%i);
				%bricks = %group.getCount();
				for(%j=0;%j<%bricks;%j++)
					%group.getObject(%j).dontRefund = 1;
			}
			solarApocToolSturdiumImage.displayName = $EOTW::SaveData::SturdiumName @ " Pick";
			solarApocToolSturdiumItem.uiName = $EOTW::SaveData::SturdiumName @ " Pick";
			deleteVariables("$EOTW::PlayerData*");
			//BrickGroup_1337.delete();
			cancel($GatherableLoop);
			EOTW_SetColors();
			cancel($EnvMasterLoop);
			%groups = MainBrickgroup.getCount();
			for(%i=0;%i<%groups;%i++)
			{
				%group = MainBrickgroup.getObject(%i);
				%bricks = %group.getCount();
				for(%j=0;%j<%bricks;%j++)
				{
					%brick = %group.getObject(%j);
					if(%brick.material !$= "")
						%brick.killBrick();
				}
			}
			servercmdEnvMaster(EnvMaster);
			messageAll('MsgAdminForce', "\c6Congratulations, survivors! \c2Starting a new round!");
			for(%i=0;%i<ClientGroup.getCount();%i++)
			{
				%client = ClientGroup.getObject(%i);
				if(%client.hasSpawnedOnce)
					%client.instantRespawn();
			}
			return;
		}
		switch(%day)
		{
		//	case 5: %msg = "\c3Environment Notice\c6: Grass seeds will no longer spawn for collection."; //removed grass
		//	case 7: %msg = "\c3Environment Notice\c6: Grass will now die if directly exposed to the sun."; //removed grass
			case 10: %msg = "\c0Environment Warning\c6: It is no longer safe to scavenge during the day.";
			case 14: %msg = "\c3Environment Notice\c6: Vines will now die if directly exposed to the sun.";
			case 15: %msg = "\c3Environment Notice\c6: Wood and vine seeds will no longer spawn for collection.";
			case 20: %msg = "\c0Environment Warning\c6: Wood and dead plants will now ignite if exposed to the sun.";
			case 25: %msg = "\c3Environment Notice\c6: Stone will no longer spawn for collection.";
			case 30: %msg = "\c0Environment Warning\c6: Meteors are raining from the sky; collisions may severely damage structures.";
			case 35: %msg = "\c3Environment Notice\c6: Glass will no longer spawn for collection.";
		//	case 37: %msg = "\c3Environment Notice\c6: Grass will now die even when indoors.";  //removed interior stuff burning //removed grass
			case 38: %msg = "\c0Environment Warning\c6: Players can now catch fire if exposed to the sun, fire, or other burning players.";
		//	case 40: %msg = "\c0Environment Warning\c6: Zombies immune to the immense heat have been spotted heading this way.";   //Unimplemented
		//	case 41: %msg = "\c0Environment Warning\c6: Ignitable materials will now catch fire even when indoors."; //removed interior stuff burning
		//	case 42: %msg = "\c3Environment Notice\c6: Life, the Universe, and everything.";
		//	case 43: %msg = "\c0Environment Warning\c6: The heat-proof zombies have arrived.";   //Unimplemented
			case 43: %msg = "\c3Environment Notice\c6: A new material has been discovered. It has been given the temporary name of " @ $EOTW::SaveData::SturdiumName @ ".";
			case 44: %msg = "\c0Environment Warning\c6: Stone will now disintegrate if exposed to the sun.";
			case 45: %msg = "\c3Environment Notice\c6: Metal will no longer spawn for collection.";
		//	case 47: %msg = "\c3Environment Notice\c6: Vines will now die even when indoors."; //removed interior stuff burning
			case 47: %msg = "\c0Environment Warning\c6: Metal will now melt if exposed to the sun.";
		//	case 48: %msg = "\c3Environment Notice\c6: Players no longer regenerate over time.";
			case 48: %msg = "\c3Environment Notice\c6: " @ $EOTW::SaveData::SturdiumName @ " will no longer spawn for collection.";
			case 49: %msg = "\c3Environment Notice\c6: No material except for " @ $EOTW::SaveData::SturdiumName @ " can withstand the heat, even when indoors.";
			case 50: %msg = "\c0Environment Warning\c6: The heat has reached critical levels; no known materials can withstand it.";
			
			//removed post 50 day content, original gamemode ended after day 60.
		//	case 53: %msg = "\c3Environment Notice\c6: A new material has been discovered. It has been given the temporary name of " @ $EOTW::SaveData::SturdiumName @ ".";
		//	case 55: %msg = "\c3Environment Notice\c6: " @ $EOTW::SaveData::SturdiumName @ " will no longer spawn for collection.";
		//	case 57: %msg = "\c3Environment Notice\c6: No material except for " @ $EOTW::SaveData::SturdiumName @ " can withstand the heat, even when indoors.";
		//	case 58: %msg = "\c3Environment Notice\c6: " @ $EOTW::SaveData::SturdiumName @ " will no longer withstand the heat.";
		}
		messageAll('', "\c6The sun rises on Day " @ %day @ ".");
		messageAll('', %msg);
		%color = vectorAdd(%color, %colInc);
		if(vectorDist(%color, %colTarg) == 0)
		{
			switch$(%colTarg)
			{
				case "1 0 0":
					if(%colInc $= "0.1 0 0")
					{
						%colInc = "0 0.1 0";
						%colTarg = "1 1 0";
					}
					else
					{
						%colInc = "0 0 0";
						%colTarg = "0 0 0";
					}
				case "1 1 0":
					%colInc = "-0.1 0 0";
					%colTarg = "0 1 0";
				case "0 1 0":
					%colInc = "0 0 0.1";
					%colTarg = "0 1 1";
				case "0 1 1":
					%colInc = "0 -0.1 0";
					%colTarg = "0 0 1";
				case "0 0 1":
					%colInc = "0.1 0.1 0";
					%colTarg = "1 1 1";
				case "1 1 1":
					%colInc = "0 0 0";
					%colTarg = "0 0 0";
			}
		}
		servercmdEnvGui_SetVar(EnvMaster, "SunFlareColor", %color);
	}
	
	export("$EOTW::SaveData::*", "config/server/SolarApoc/save.cs");
	if(%time >= 180 && !$hasHitSunsetOnce)
	{
		$hasHitSunsetOnce = true;
		if(%day >= 50) //if(%day >= 60)
		{
			$EOTW::SaveData::Day = "";
			$EOTW::SaveData::Time = "";
			$EOTW::SaveData::SturdiumName = "???";
			
			%groups = MainBrickgroup.getCount();
			for(%i=0;%i<%groups;%i++)
			{
				%group = MainBrickgroup.getObject(%i);
				%bricks = %group.getCount();
				for(%j=0;%j<%bricks;%j++)
					%group.getObject(%j).dontRefund = 1;
			}
			solarApocToolSturdiumImage.displayName = $EOTW::SaveData::SturdiumName @ " Pick";
			solarApocToolSturdiumItem.uiName = $EOTW::SaveData::SturdiumName @ " Pick";
			deleteVariables("$EOTW::PlayerData*");
			//BrickGroup_1337.delete();
			cancel($GatherableLoop);
			EOTW_SetColors();
			cancel($EnvMasterLoop);
			%groups = MainBrickgroup.getCount();
			for(%i=0;%i<%groups;%i++)
			{
				%group = MainBrickgroup.getObject(%i);
				%bricks = %group.getCount();
				for(%j=0;%j<%bricks;%j++)
				{
					%brick = %group.getObject(%j);
					if(%brick.material !$= "")
						%brick.killBrick();
				}
			}
			servercmdEnvMaster(EnvMaster);
			messageAll('MsgAdminForce', "\c6Congratulations, survivors! \c2Starting a new round!");
			for(%i=0;%i<ClientGroup.getCount();%i++)
			{
				%client = ClientGroup.getObject(%i);
				if(%client.hasSpawnedOnce)
					%client.instantRespawn();
			}
			return;
		}
		if(%day >= 10 && %day < 48)
			messageAll('', "\c6The sun sets on Day " @ %day @ ". It is now safe to scavenge.");
		else
			messageAll('', "\c6The sun sets on Day " @ %day @ ".");
		servercmdEnvGui_SetVar(EnvMaster, "SunFlareColor", "0 0 0");
		for(%i = 0; %i < ClientGroup.getCount(); %i++)
		{
			%client = ClientGroup.getObject(%i);
			if(%client.HasDied)
			{
				%client.HasDied = false;
				%client.instantRespawn();
			}
			
			if($EOTW::PlayerData[%client.bl_id, "ResearchDaysLeft"] > 0)
				$EOTW::PlayerData[%client.bl_id, "ResearchDaysLeft"]--;
			else if($EOTW::PlayerData[%client.bl_id, "ResearchDaysLeft"] <= 0)
			{
				%researched = $EOTW::PlayerData[%client.bl_id, "Researching"];
				if(%researched !$= "")
				{
					%client.chatMessage("\c6You have finished researching " @ %researched @ "! " @ $EOTW::PlayerData[%client.bl_id, "ResearchingMessage"]);
					%researched = strReplace(%researched, " ", "");
					$EOTW::PlayerData[%client.bl_id, "Researched" @ %researched] = true;
					$EOTW::PlayerData[%client.bl_id, "Researching"] = "";
				}
			}
			
			if($EOTW::PlayerData[%client.bl_id, "ResearchedAdvancedMedical"])
				$EOTW::PlayerData[%client.bl_id, "CurrentPill"] = "solarApocSuperHealthPillItem";
			else if($EOTW::PlayerData[%client.bl_id, "ResearchedMedical"])
				$EOTW::PlayerData[%client.bl_id, "CurrentPill"] = "solarApocHealthPillItem";
			else
				$EOTW::PlayerData[%client.bl_id, "CurrentPill"] = "solarApocEmptyItem";
		}
	}
	if(%time > 180)
	{
		$EOTW::IsDay = 0;
		%flare = 0;
		%realA = 1 - (mAbs(%time - 90) / 120);
		%realB = 1 - (mAbs(%time - 450) / 120);
		%realFlare = getMax(%realA, %realB);
		if(%realFlare < 0) %realFlare = 0;
	}
	else
	{
		$EOTW::IsDay = 1;
		%flare = 1 - (mAbs(%time - 90) / 120);
		%realFlare = %flare;
		if(%day >= 20)
		{
			for(%i=0;%i<mCeil(getBrickCount()/2000);%i++)
			{
				%groups = MainBrickgroup.getCount();
				for(%j=0;%j<%groups;%j++)
					%bricks[%j] = MainBrickgroup.getObject(%j).getCount() + %bricks[%j - 1];
				%highest = %bricks[%groups - 1];
				%select = getRandom(1, %highest);
				while(%bricks[%sel] < %select)
					%sel++;
				%group = MainBrickgroup.getObject(%sel);
				if(isObject(%group))
				{
					%bricks = %group.getCount();
					while(%bricks == 0 && %sel < %groups)
						%sel++;
					if(%sel < %groups)
					{
						if(%bricks != 0)
						{
							%brick = %group.getObject(getRandom(0, %bricks - 1));
							if(%brick.isIgnitable)
							{
								//if(%day >= 41)
								//	%brick.burnLoop(getSimTime());
								//else
								//{
									%pi = 3.14159265; %val = (%time / 180) * %pi;
									%ang = ($EnvGuiServer::SunAzimuth / 180) * %pi;
									%dir = vectorScale(mSin(%ang) * mCos(%val) SPC mCos(%ang) * mCos(%val) SPC mSin(%val), 512);
									%ray = containerRaycast(vectorAdd(%pos = %brick.getPosition(), %dir), %pos, $Typemasks::fxBrickAlwaysObjectType | $Typemasks::StaticShapeObjectType);
									if(!isObject(%hit = firstWord(%ray)) || %hit == %brick)
										%brick.burnLoop(getSimTime());
								//}
							}
						}
					}
				}
			}
		}
		if(%day >= 30)
		{
			%pi = 3.14159265; %val = (%time / 180) * %pi;
			%ang = ($EnvGuiServer::SunAzimuth / 180) * %pi;
			%dir = vectorScale(mSin(%ang) * mCos(%val) SPC mCos(%ang) * mCos(%val) SPC mSin(%val), 512);
			%hit = getRandom(-1000, 1000) SPC getRandom(-1000, 1000) SPC 0;
			%proj = new Projectile()
			{
				datablock = EOTWFireballProjectile;
				initialPosition = vectorAdd(%hit, vectorScale(%dir, 1));
				initialVelocity = vectorScale(%dir, -100);
			};
		}
		if(%day >= 44)
		{
			if(mAbs(%time * 10 - mFloor(%time * 10)) <= 0.05)
			{
				for(%i=0;%i<mCeil(getBrickCount()/(1000/(%day-49)));%i++)
				{
					%groups = MainBrickgroup.getCount();
					for(%j=0;%j<%groups;%j++)
						%bricks[%j] = MainBrickgroup.getObject(%j).getCount() + %bricks[%j - 1];
					%highest = %bricks[%groups - 1];
					%select = getRandom(1, %highest);
					while(%bricks[%sel] < %select) %sel++;
					while(MainBrickgroup.getObject(%sel).getCount() == 0 && %sel < %groups) %sel++;
					%group = MainBrickgroup.getObject(%sel);
					%bricks = %group.getCount();
					if(%bricks != 0)
					{
						%brick = %group.getObject(getRandom(0, %bricks - 1));
						if(%day >= 47)
						{
							if(%brick.isBreakable || %day >= 50)//if(%brick.isBreakable || %day >= 58)
							{
								if(%day >= 49 && %brick.isBreakable)//if(%day >= 57 && %brick.isBreakable)
									%brick.killBrick();
								else
								{
									%pi = 3.14159265; %val = (%time / 180) * %pi;
									%ang = ($EnvGuiServer::SunAzimuth / 180) * %pi;
									%dir = vectorScale(mSin(%ang) * mCos(%val) SPC mCos(%ang) * mCos(%val) SPC mSin(%val), 160);
									%ray = containerRaycast(vectorAdd(%pos = %brick.getPosition(), %dir), %pos, $Typemasks::fxBrickAlwaysObjectType | $Typemasks::StaticShapeObjectType);
									if(!isObject(%hit = firstWord(%ray)) || %hit == %brick)
										%brick.killBrick();
								}
							}
						}
						else if(%brick.canBeFireballed)
						{
							%pi = 3.14159265; %val = (%time / 180) * %pi;
							%ang = ($EnvGuiServer::SunAzimuth / 180) * %pi;
							%dir = vectorScale(mSin(%ang) * mCos(%val) SPC mCos(%ang) * mCos(%val) SPC mSin(%val), 160);
							%ray = containerRaycast(vectorAdd(%pos = %brick.getPosition(), %dir), %pos, $Typemasks::fxBrickAlwaysObjectType | $Typemasks::StaticShapeObjectType);
							if(!isObject(%hit = firstWord(%ray)) || %hit == %brick)
								%brick.killBrick();
						}
					}
				}
			}
		}
	}
	%pi = 3.14159265;
	%val = (%time / 180) * %pi;
	%ang = ($EnvGuiServer::SunAzimuth / 180) * %pi;
	%dir = vectorScale(mSin(%ang) * mCos(%val) SPC mCos(%ang) * mCos(%val) SPC mSin(%val), 512);
	%pos[-1+%posCount++] = "0 0 0";
	for(%i=0;%i<ClientGroup.getCount();%i++)
		if(isObject(%player = ClientGroup.getObject(%i).player))
		%pos[-1+%posCount++] = %player.getPosition();
	for(%i=0;%i<%posCount;%i++)
	{
		initContainerRadiusSearch(%pos[%i], 240, $Typemasks::PlayerObjectType);
		while(isObject(%obj = containerSearchNext()))
		{
			if(%obj.getState() !$= "DEAD" && !%hasHarmed[%obj])
			{
				%hasHarmed[%obj] = 1;
				%hit = containerRaycast(vectorAdd(%pos = %obj.getHackPosition(), %dir), %pos, $Typemasks::fxBrickObjectType | $Typemasks::StaticShapeObjectType);
				if(!isObject(%hit) && %size >= 1 && %flare != 0)
				{
					if(%obj.getDamagePercent() >= 1)
						%obj.damage(0, 0, 10000, $DamageType::Sun);
					else
					{
						%damage = %obj.getDamageLevel() + ((%size / 4) * ($SampleRate + 1) * 5);
						if(%damage >= 100 && !%obj.immuneToSun)
							%obj.damage(0, 0, 10000, $DamageType::Sun);
						else
						{
							if(!%obj.immuneToSun)
							{
								%obj.setDamageLevel(%damage);
								%obj.setDamageFlash(0.25);
							}
							if(%day >= 38 && !%obj.immuneToFire)
							{
								%obj.burningTime += (%day / 50) * ($SampleRate + 1) * (%obj.tripleFire ? 3 : 1);
								if(!isEventPending(%obj.burnLoop))
									%obj.burnLoop(getSimTime());
							}
						}
						if(isObject(%client = %obj.client) && !%obj.immuneToSun)
							%client.centerPrint("<color:FF8000>Get into a shaded area!<br>"@%client.getHealthText(), 2);
						if(%obj.immuneToSun && %obj.deimmuneTime > 0)
						{
							%obj.deimmuneTime -= (100 * ($SampleRate + 1));
							if(%obj.deimmuneTime <= 0)
							{
								%obj.deimmuneTime = 0;
							}
							%obj.immuneToSun = 0;
							%obj.immuneToFire = 0;
							%obj.immuneToBurn = 0;
							%obj.immuneToMeteors = 0;
						}
					}
				}
				else if(%obj.getDamageLevel() > 0) //&& $EOTW::SaveData::Day < 48)
					%obj.setDamageLevel(%obj.getDamageLevel() - (0.01 * ($SampleRate + 1)));
			}
		}
	}
	for(%i = 0; %i < ClientGroup.getCount(); %i++)
	{
		%client = ClientGroup.getObject(%i);
		%client.showEOTWHud();
		%player = %client.player;
		if(isObject(%player))
		{
			//make sure they're the no jet player
			%data = %player.getDatablock();
			if(%data.getName() !$= "PlayerNoJet")
				%player.setDatablock(PlayerNoJet);
			
			//make sure they have the right items
			if(%player.tool[0] != hammerItem.getID())
			{
				%player.tool[0] = hammerItem.getID();
				messageClient(%client, 'MsgItemPickup', '', 0, hammerItem.getID());
			}
			
			if(%player.tool[1] != wrenchItem.getID())
			{
				%player.tool[1] = wrenchItem.getID();
				messageClient(%client, 'MsgItemPickup', '', 1, wrenchItem.getID());
			}
			
			if(%player.tool[2] != printGun.getID())
			{
				%player.tool[2] = printGun.getID();
				messageClient(%client, 'MsgItemPickup', '', 2, printGun.getID());
			}
			
			if($EOTW::PlayerData[%client.bl_id, "CurrentTool"] $= "")
				$EOTW::PlayerData[%client.bl_id, "CurrentTool"] = "solarApocToolHandsImage";
			if(%player.tool[3] != $EOTW::PlayerData[%client.bl_id, "CurrentTool"].fakeItem.getID())
			{
				%player.tool[3] = $EOTW::PlayerData[%client.bl_id, "CurrentTool"].fakeItem.getID();
				messageClient(%client, 'MsgItemPickup', '', 3, $EOTW::PlayerData[%client.bl_id, "CurrentTool"].fakeItem.getID());
			}
			
			if($EOTW::PlayerData[%client.bl_id, "CurrentPill"] $= "")
				$EOTW::PlayerData[%client.bl_id, "CurrentPill"] = "solarApocEmptyItem";
			if($EOTW::PlayerData[%client.bl_id, "Pills"] > 0)
			{
				if(%player.tool[4] != $EOTW::PlayerData[%client.bl_id, "CurrentPill"].getID())
				{
					%player.tool[4] = $EOTW::PlayerData[%client.bl_id, "CurrentPill"].getID();
					messageClient(%client, 'MsgItemPickup', '', 4, $EOTW::PlayerData[%client.bl_id, "CurrentPill"].getID());
				}
			}
			else
			{
				if(%player.tool[4] != solarApocEmptyItem.getID())
				{
					%player.tool[4] = solarApocEmptyItem.getID();
					messageClient(%client, 'MsgItemPickup', '', 4, solarApocEmptyItem.getID());
				}
			}
		}
	}
	if(%time >= 330 || %time <= 210)
	{
		if(%time >= 330)
			%colTime = %time - 360;
		else
			%colTime = %time;
		%colVal = 1 - mAbs((%colTime - 90) / 120);
	}
	else
		%colVal = 0;
	if(%time >= 345 || %time <= 15)
	{
		%fogTime = -(mAbs(%time - 180) - 180);
		%fogVal = 1 - (%fogTime / 15);
	}
	else if(%time >= 165 && %time <= 195)
		%fogVal = 1 - mAbs((%time - 180) / 15);
	else
		%fogVal = 0;
	if(%fogVal >= 0)
		servercmdEnvGui_SetVar(EnvMaster, "FogColor", vectorScale(vectorAdd(vectorScale(%color, %fogVal), vectorScale(%color, %colVal)), 0.8));
	%sizeVal = %colVal * mSqrt(%flare);
	%realSizeVal = %colVal * mSqrt(%realFlare);
	%sunCol = vectorScale(%color, (%realSizeVal + %sizeVal) * 0.5);
	%ambCol = vectorScale(%color, %realSizeVal * 0.7);
	%shadCol = vectorScale(%color, %realSizeVal * 0.4);
	servercmdEnvGui_SetVar(EnvMaster, "VignetteColor", vectorScale(%color, %colVal) SPC ((%size * %colVal) / 5));
	servercmdEnvGui_SetVar(EnvMaster, "SkyColor", vectorScale(%color, %colVal));
	servercmdEnvGui_SetVar(EnvMaster, "DirectLightColor", %sunCol);
	servercmdEnvGui_SetVar(EnvMaster, "AmbientLightColor", %ambCol);
	servercmdEnvGui_SetVar(EnvMaster, "ShadowColor", %shadCol);
	servercmdEnvGui_SetVar(EnvMaster, "SunElevation", %time);
	servercmdEnvGui_SetVar(EnvMaster, "SunFlareSize", (%val = (mSqrt(%flare) * %size)) < 0.1 ? 0.1 : %val);
	
	$EOTW::SaveData::Day = %day;
	
	//if(%day <= 10) $EOTW::SaveData::Time = %time + (0.12 * ($SampleRate + 1));
	//else if(%day <= 20) $EOTW::SaveData::Time = %time + (0.10 * ($SampleRate + 1));
	//else if(%day <= 30) $EOTW::SaveData::Time = %time + (0.08 * ($SampleRate + 1));
	//else if(%day <= 40) $EOTW::SaveData::Time = %time + (0.06 * ($SampleRate + 1));
	//else if(%day <= 50) $EOTW::SaveData::Time = %time + (0.04 * ($SampleRate + 1));
	//else $EOTW::SaveData::Time = %time + (0.02 * ($SampleRate + 1));
	
	if(%day <= 10) $EOTW::SaveData::Time = %time + (0.12 * ($SampleRate + 1));
	else if(%day <= 20) $EOTW::SaveData::Time = %time + (0.16 * ($SampleRate + 1));
	else if(%day <= 30) $EOTW::SaveData::Time = %time + (0.20 * ($SampleRate + 1));
	else if(%day <= 40) $EOTW::SaveData::Time = %time + (0.24 * ($SampleRate + 1));
	else if(%day <= 50) $EOTW::SaveData::Time = %time + (0.28 * ($SampleRate + 1));
	else $EOTW::SaveData::Time = %time + (0.12 * ($SampleRate + 1)); //final day is long
	
	$EnvMasterLoop = schedule((100 * ($SampleRate + 1)), 0, "EnvMasterLoop", $EOTW::SaveData::Time, $EOTW::SaveData::Day, %color, %colInc, %colTarg, %size);
}

function servercmdEnvMaster(%client)
{
	if(isObject(%client) && !%client.isSuperAdmin)
		return;
	if(!isEventPending($EnvMasterLoop))
	{
		if(!isObject(EnvMaster))
			new ScriptObject(EnvMaster) { isAdmin = 1; isSuperAdmin = 1; environMaster = 1; };
		
		//EnvMasterLoop(360, 0, "0 0 0", "0.1 0 0", "1 0 0", 0);
		EnvMasterLoop(1440, 0, "1 1 1", "0.00 -0.02 -0.02", "1 0 0", 0);
		//servercmdEnvGui_SetVar(EnvMaster, "SkyIdx", 11);
		//servercmdEnvGui_SetVar(EnvMaster, "GroundIdx", 6);
		servercmdEnvGui_SetVar(EnvMaster, "SunAzimuth", 180);
		schedule(96, 0, "servercmdEnvGui_SetVar", EnvMaster, "SunAzimuth", 75);
		//servercmdEnvGui_SetVar(EnvMaster, "SunFlareTopIdx", 2);
		//servercmdEnvGui_SetVar(EnvMaster, "SunFlareBottomIdx", 4);
		servercmdEnvGui_SetVar(EnvMaster, "SunFlareSize", 10);
		servercmdEnvGui_SetVar(EnvMaster, "WaterColor", "0.0 0.5 1.0 0.5");
		servercmdEnvGui_SetVar(EnvMaster, "UnderwaterColor", "0.0 0.5 1.0 0.5");
		servercmdEnvGui_SetVar(EnvMaster, "GroundColor", "0.1 0.3 0.2 1.0");
		
		if(!$EOTW_ClearedEvents)
			clearIllegalEvents();
		cancel($GatherableLoop);
		GatherableLoop();
	}
}

function servercmdResetSolarApoc(%client)
{
	if(isObject(%client) && !%client.isSuperAdmin)
		return;
	
	messageAll('MsgAdminForce', "\c2Resetting Solar Apocalypse gamemode by skipping to the end...");
	cancel($EnvMasterLoop);
	$EOTW::SaveData::Day = 50;
	$EOTW::SaveData::Time = 180;
	$EnvMasterLoop = schedule(0, 0, "EnvMasterLoop", $EOTW::SaveData::Time, $EOTW::SaveData::Day);
}

function clearIllegalEvents()
{
	unregisterOutputEvent("fxDtsBrick", "setItem");			//People shoot projectiles at others.
	unregisterOutputEvent("fxDtsBrick", "spawnExplosion");	//Assholes try to lag the server up.
	unregisterOutputEvent("fxDtsBrick", "spawnItem");		//People shoot projectiles at others.
	unregisterOutputEvent("fxDtsBrick", "spawnProjectile");	//People shoot projectiles at others.
	unregisterInputEvent("fxDTSBrick", "onBotTouch");		//bots
	unRegisterInputEvent("fxDTSBrick", "onMiniGameReset");	//very abusable/pointless event
	unRegisterOutputEvent("fxDTSBrick", "radiusImpulse");	//launching players/abusable with relays/can create invisible barriers/nobody uses it
	
	unregisterOutputEvent("Player", "addHealth");			//This is a survival-based gamemode. No healing.
	unregisterOutputEvent("Player", "changeDatablock");		//Incredibly abusable; people give themselves jets.
	unregisterOutputEvent("Player", "clearTools");			//People *will* use this to clear others' tools.
	unregisterOutputEvent("Player", "instantRespawn");		//Death traps and the like. People are assholes.
	unregisterOutputEvent("Player", "kill");				//Death traps and the like. People are assholes.
	unregisterOutputEvent("Player", "setHealth");			//This is a survival-based gamemode. No healing.
	unregisterOutputEvent("Player", "spawnExplosion");		//Assholes try to lag the server up.
	unregisterOutputEvent("Player", "spawnProjectile");		//People shoot projectiles at others.
	unregisterOutputEvent("Player", "setPlayerScale");		//really annoying
	unregisterOutputEvent("Player", "setVelocity");			//abusable, just make stairs
	unregisterOutputEvent("Player", "addVelocity");			//abusable, just make stairs
	
	unRegisterOutputEvent("gameConnection", "incScore");	//does not use minigame score/cant even use this to abuse/totally useless for those reasons
	unRegisterOutputEvent("gameConnection", "bottomPrint");	//hud is on bottom print/would be pointless to use it
	unRegisterOutputEvent("gameConnection", "setCameraBrick");	//abusable
	unRegisterOutputEvent("gameConnection", "setCameraNormal");	//abusable
	
	unRegisterOutputEvent("MiniGame", "bottomPrintAll");	//very abusable/hud is on bottom print/would be pointless to use it
	unRegisterOutputEvent("MiniGame", "reset");				//very abusable/pointless event
	unRegisterOutputEvent("MiniGame", "centerPrintAll");	//abusable
	unRegisterOutputEvent("MiniGame", "chatMsgAll");		//abusable
	unRegisterOutputEvent("MiniGame", "respawnAll");		//respawns all players
	unRegisterOutputEvent("MiniGame", "setCameraBrick");	//abusable
	unRegisterOutputEvent("MiniGame", "setCameraNormal");	//abusable
	
	$EOTW_ClearedEvents = true;
}

function GameConnection::getHealthText(%client)
{
	%player = %client.player;
	if(isObject(%player))
	{
		%bars = mCeil((100 - %player.getDamageLevel()) / 5);
		for(%i=0;%i<%bars;%i++)
			%bar0 = %bar0@"|";
		for(%i=%bars;%i<20;%i++)
			%bar1 = %bar1@"|";
		
		if(%obj.isHealing)
			%color = "\c4";
		else
			%color = "\c2";
		
		return "\c6Health" @ %color @ ": " @ %bar0 @ "\c0" @ %bar1;
	}
	else
		return "\c6Health\c0: ||||||||||||||||||||";
}

function GameConnection::getTimeText(%client)
{
	%day = $EOTW::SaveData::Day;
	%time = $EOTW::SaveData::Time;
	
	if($EOTW::IsDay)
		%color = "\c3";
	else
		%color = "\c1";
	
	if(%client.showRawTime)
		return "\c6Time" @ %color @ ": " @ $EOTW::SaveData::Time @ "   \c6Day" @ %color @ ": " @ %day;
	else
	{
		%timeOfDay = %time + 90;
		if(%timeOfDay > 360)
			%timeOfDay -= 360;
		
		%hours = mFloor(%timeOfDay / 15);
		%mins = mFloor((%timeOfDay - (%hours * 15)) * 4);
		
		if(%hours >= 12)
		{
			%hours -= 12;
			%suffix = "PM";
		}
		else
			%suffix = "AM";
		
		if(%hours == 0)
			%hours += 12;
		if(strLen(%mins) == 1)
			%mins = "0" @ %mins;
		
		return "\c6Time" @ %color @ ": " @ %hours @ ":" @ %mins SPC %suffix @ "   \c6Day" @ %color @ ": " @ %day;
	}
}

function GameConnection::showEOTWHud(%client)
{
	%player = %client.player;
	
	//health
	%health = %client.getHealthText();
	
	//materials
	%materials = %client.getMaterialText();
	
	//time
	%time = %client.getTimeText();
	
	//print it
	%client.bottomPrint(%time @ "<just:right>" @ %health @ " <br><just:left>" @ %materials @ " ", 0);
}

function servercmdShowRawTime(%client)
{
	if(!%client.showRawTime)
		%client.showRawTime = true;
	else if(%client.showRawTime)
		%client.showRawTime = false;
}

//SkyIdx 9
//WaterIdx 4
//GroundIdx 6
//SunAzimuth
//SunElevation
//DirectLightColor
//AmbientLightColor
//ShadowColor
//SunFlareTopIdx 2
//SunFlareBottomIdx 4
//SunFlareColor R G B (A = 1)
//SunFlareSize: Size (0 to 5)
//SkyColor R G B (A = 1)
//WaterColor R G B A
//UnderwaterColor R G B A
//WaterScrollX
//WaterScrollY
//GroundColor R G B (A = 1)
//VignetteColor