function EOTW_SetColors()
{
	$EOTW::Colors::Dead		= getClosestColor("0.60 0.60 0.30 1.00");   //153 153 077
	$EOTW::Colors::Charcoal	= getClosestColor("0.00 0.00 0.00 0.00");   //000 000 000
	$EOTW::Colors::Glass	= getClosestColor("1.00 1.00 1.00 0.50");   //128 128 128
	$EOTW::Colors::Grass	= getClosestColor("0.05 0.75 0.15 1.00");   //013 191 038
	$EOTW::Colors::Metal	= getClosestColor("0.25 0.25 0.25 1.00");   //089 089 102
	$EOTW::Colors::Stone	= getClosestColor("0.50 0.50 0.50 1.00");   //191 191 204
	$EOTW::Colors::Sturdium	= getClosestColor("0.00 0.00 0.50 1.00");   //051 051 064
	$EOTW::Colors::Vine		= getClosestColor("0.05 0.35 0.15 1.00");   //013 089 038
	$EOTW::Colors::Wood		= getClosestColor("0.40 0.25 0.05 1.00");   //128 089 038
}
EOTW_SetColors();

function servercmdMaterialDebug(%client)
{
	if(isObject(%client) && !%client.isSuperAdmin)
		return;
	
	if(!%client.materialDebug)
		%client.materialDebug = true;
	else if(%client.materialDebug)
		%client.materialDebug = false;
}

if(isPackage(EOTW_Materials))
	deactivatePackage(EOTW_Materials);
package EOTW_Materials
{
	function Armor::onTrigger(%data, %this, %trig, %tog)
	{
		if(isEventPending($EnvMasterLoop) && isObject(%client = %this.client))
		{
			if(%trig == 0 && !(isObject(%this.getMountedImage(0)) && %tog))
			{
				if(%tog)
				{
					%eye = %this.getEyePoint();
					%dir = %this.getEyeVector();
					%for = %this.getForwardVector();
					%face = getWords(vectorScale(getWords(%for, 0, 1), vectorLen(getWords(%dir, 0, 1))), 0, 1) SPC getWord(%dir, 2);
					%mask = $Typemasks::fxBrickAlwaysObjectType | $Typemasks::TerrainObjectType;
					%ray = containerRaycast(%eye, vectorAdd(%eye, vectorScale(%face, 5)), %mask, %this);
					if(isObject(%hit = firstWord(%ray)) && %hit.getClassName() $= "fxDtsBrick" && %hit.isCollectable)
					{
						if(%hit.beingCollected)
							%client.centerPrint("<just:right><color:FFFFFF>Someone is already collecting that material brick!", 3);
						else
						{
							%hit.beingCollected = 1;
							%hit.cancelCollecting = %hit.schedule(48, "cancelCollecting");
							%this.collectLoop(%hit, getSimTime());
							%client.material = %hit.material;
						}
					}
				}
				else if(isEventPending(%this.collectLoop))
					cancel(%this.collectLoop);
			}
			else if(%trig == 4) //((isObject(%image = %this.getMountedImage(0)) && %image.getName() $= "BrickImage") || isEventPending(%this.collectLoop))
			{
				if(%tog)
				{
					if(%client.materialDebug)
					{
						switch$(%client.material)
						{
							case "Dead_Plant": %client.material = "Charcoal";
							case "Charcoal": %client.material = "Glass";
							case "Glass": %client.material = "Grass";
							case "Grass": %client.material = "Metal";
							case "Metal": %client.material = "Stone";
							case "Stone": %client.material = "Sturdium";
							case "Sturdium": %client.material = "Vine";
							case "Vine": %client.material = "Wood";
							case "Wood": %client.material = "Dead_Plant";
						}
					}
					else
					{
						switch$(%client.material)
						{
							case "Dead_Plant": %client.material = "Glass";
							case "Charcoal": %client.material = "Glass";
							case "Glass": %client.material = "Metal";
							case "Grass": %client.material = "Metal";
							case "Metal": %client.material = "Stone";
							case "Stone":
								if($EOTW::PlayerData[%client.bl_id, "Material", "Sturdium"] > 0)
									%client.material = "Sturdium";
								else
									%client.material = "Vine";
							case "Sturdium": %client.material = "Vine";
							case "Vine": %client.material = "Wood";
							case "Wood": %client.material = "Glass";
						}
					}
					%client.showEOTWHud();
				}
			}
		}
		Parent::onTrigger(%data, %this, %trig, %tog);
	}
};
activatePackage("EOTW_Materials");

function fxDtsBrick::cancelCollecting(%brick, %player)
{
	%brick.beingCollected = 0;
	%player.unmountSolApocTool();
}

function GameConnection::getMaterialText(%client)
{
	if(%client.material $= "")
		%client.material = "Wood";
	%material = %client.material;
	%amount = mfloor($EOTW::PlayerData[%client.bl_id, "Material", %client.material]);
	
	if(%client.materialDebug)
	{
		if(%material $= "Dead_Plant" || %material $= "Charcoal" || %material $= "Grass")
			%amount = "???";
		
		switch$(%material)
		{
			case "Dead_Plant":	%next = "Charcoal";
			case "Charcoal":	%next = "Glass";
			case "Glass":		%next = "Grass";
			case "Grass":		%next = "Metal";
			case "Metal":		%next = "Stone";
			case "Stone":		%next = "Sturdium";
			case "Sturdium":	%next = "Vine";
			case "Vine":		%next = "Wood";
			case "Wood":		%next = "Dead_Plant";
		}
	}
	else
	{
		if(%material $= "Dead_Plant" || %material $= "Charcoal" || %material $= "Grass")
			%amount = "STOP HACKING MY GAME.";
		
		switch$(%material)
		{
			case "Dead_Plant":	%next = "MISSINGNO";
			case "Charcoal":	%next = "MISSINGNO";
			case "Glass":		%next = "Metal";
			case "Grass":		%next = "MISSINGNO";
			case "Metal":		%next = "Stone";
			case "Stone":		%next = ($EOTW::PlayerData[%client.bl_id, "Material", "Sturdium"] > 0 ? $EOTW::SaveData::SturdiumName : "Vine");
			case "Sturdium":	%next = "Vine";
			case "Vine":		%next = "Wood";
			case "Wood":		%next = "Glass";
		}
	}
	
	switch$(%material)
	{
		case "Dead_Plant":	%color = "<color:99994D>";
		case "Charcoal":	%color = "<color:333333>";
		case "Glass":		%color = "<color:808080>";
		case "Grass":		%color = "<color:0EBF26>";
		case "Metal":		%color = "<color:595966>";
		case "Stone":		%color = "<color:BFBFCC>";
		case "Sturdium":	%color = ($EOTW::SaveData::Day >= 43 ? "<color:333340>" : "<color:FFFFFF>");
		case "Vine":		%color = "<color:0E5926>";
		case "Wood":		%color = "<color:805926>";
	}
	
	return %color @ getMaterialName(%material) @ "\c6: " @ %amount @ "<just:right>\c7Next material: " @ %next @ "   (Jet to cycle)";
}

function Player::collectLoop(%player, %brick, %start)
{
	cancel(%player.unmountSolApocToolLoop);
	cancel(%player.collectLoop);
	if(!isObject(%client = %player.client) || %player.getState() $= "DEAD") return;
	if(!isObject(%brick) || %brick.isDead()) return;
	%image = %player.getMountedImage(1);
	if(!isObject(%image))
	{
		if(%player.isNodeVisible("lhand") + %player.isNodeVisible("lhook") > 0)
		{
			if(!isObject($EOTW::PlayerData[%client.bl_id, "CurrentTool"].getid()))
				$EOTW::PlayerData[%client.bl_id, "CurrentTool"] = "solarApocToolHandsImage";
			
			%player.mountImage($EOTW::PlayerData[%client.bl_id, "CurrentTool"].getid(), 1);
				
			%image = %player.getMountedImage(1);
		}
	}
	
	if(isObject(%image))
	{
		if(%image.isSolarApocTool)
		{
			if(getSimTime() - %player.lastToolSwingTime > 200)
			{
				%player.lastToolSwingTime = getSimTime();
				%player.playThread(3, "leftRecoil");
			}
		}
	}
	
	%eye = %player.getEyePoint();
	%dir = %player.getEyeVector();
	%for = %player.getForwardVector();
	%face = getWords(vectorScale(getWords(%for, 0, 1), vectorLen(getWords(%dir, 0, 1))), 0, 1) SPC getWord(%dir, 2);
	%mask = $Typemasks::fxBrickAlwaysObjectType | $Typemasks::TerrainObjectType;
	%ray = containerRaycast(%eye, vectorAdd(%eye, vectorScale(%face, 5)), %mask, %this);
	if(isObject(%hit = firstWord(%ray)) && %hit == %brick)
	{
		cancel(%brick.cancelCollecting);
		if(%brick.collectTime <= 0)
		{
			if(%brick.forceVolume !$= "")
				%volume = %brick.forceVolume;
			else
			{
				%data = %brick.getDatablock();
				%volume = %data.brickSizeX * %data.brickSizeY * %data.brickSizeZ;
			}
			%material = %brick.material;
			%client.addMaterial(%volume, %material, "Brick health: 0");
			%brick.isCollectable = 0;
			%brick.killbrick();
			%player.unmountSolApocTool();
			%client.showEOTWHud();
		}
		else
		{
			%brick.cancelCollecting = %brick.schedule(48, "cancelCollecting", %player);
			%player.collectLoop = %player.schedule(16, "collectLoop", %brick, %start);
			
			%brick.collectTime -= $EOTW::PlayerData[%client.bl_id, "CurrentTool"].collectPower;
			if(%brick.collectTime < 0)
				%brick.collectTime = 0;
			
			%material = %brick.material;
			%client.centerPrint("<just:right><color:FFFFFF>Collecting a gatherable " @ getMaterialName(%material) @ " brick.<br><just:right>Brick health: " @ %brick.collectTime, 3);
		}
	}
}

function GatherableLoop()
{
	cancel($GatherableLoop);
	if($EOTW::SaveData::Day < 35)
	{
		for(%i=0;%i<1;%i++)
			%material[-1+%materials++] = "Glass";
	}
	//if($EOTW::SaveData::Day < 5)
	//{
	//	for(%i=0;%i<2;%i++)
	//		%material[-1+%materials++] = "Grass";
	//}
	if($EOTW::SaveData::Day < 40)//if($EOTW::SaveData::Day < 45)
	{
		for(%i=0;%i<5;%i++)
			%material[-1+%materials++] = "Metal";
	}
	if($EOTW::SaveData::Day < 25)
	{
		for(%i=0;%i<7;%i++)
			%material[-1+%materials++] = "Stone";
	}
	if($EOTW::SaveData::Day >= 40 && $EOTW::SaveData::Day < 48)
	{
		for(%i=0;%i<1;%i++)
			%material[-1+%materials++] = "Sturdium";
	}
	if($EOTW::SaveData::Day < 15)
	{
		for(%i=0;%i<2;%i++)
			%material[-1+%materials++] = "Vine";
	}
	if($EOTW::SaveData::Day < 15)
	{
		for(%i=0;%i<10;%i++)
			%material[-1+%materials++] = "Wood";
	}
	if(!isObject(BrickGroup_888888) || BrickGroup_888888.getCount() < 6000)
		%material = %material[getRandom(0, 99)];
	if(%material !$= "")
		spawnGatherable(%material);
	$GatherableLoop = schedule(10, 0, "GatherableLoop");
}

function spawnGatherable(%material, %pos)
{
	if(%pos $= "")
		%pos = (getRandom(-500, 499) / 2 + 0.25) SPC (getRandom(-500, 499) / 2 + 0.25) SPC 0.1;
	setWord(%pos, 3, "0.1");
	%data = EOTW_CreateBrick(EnvMaster, brick1x1FData, %pos, $EOTW::Colors["::"@%material]); %brick = getField(%data, 0);
	%brick = getField(%data, 0);
	if(getField(%data, 1))
	{
		%brick.delete();
		return;
	}
	%brick.material = %material;
	switch$(%material)
	{
		case "Glass":
			%brick.collectTime = 10000;
			%brick.destroyOnDay = 35;
			%brick.isCollectable = 1;
			%brick.forceVolume = 20;
		case "Grass":
			%brick.collectTime = 500;
			%brick.destroyOnDay = 5;
			%brick.isCollectable = 1;
			%brick.forceVolume = 5;
		case "Metal":
			%brick.collectTime = 15000;
			%brick.destroyOnDay = 45;
			%brick.isCollectable = 1;
			%brick.forceVolume = 100;
		case "Stone":
			%brick.collectTime = 5000;
			%brick.destroyOnDay = 25;
			%brick.isCollectable = 1;
			%brick.forceVolume = 125;
		case "Sturdium":
			%brick.collectTime = 30000;
			%brick.destroyOnDay = 48; //old: 55
			%brick.isCollectable = 1;
			%brick.forceVolume = 250; //old: 50
		case "Vine":
			%brick.collectTime = 1000;
			%brick.destroyOnDay = 15;
			%brick.isCollectable = 1;
			%brick.forceVolume = 5;
		case "Wood":
			%brick.collectTime = 2000;
			%brick.destroyOnDay = 15;
			%brick.isCollectable = 1;
			%brick.forceVolume = 1000;
	}
	//if(!isObject(BrickGroup_1337))
	//	MainBrickgroup.add(new SimGroup(BrickGroup_1337) { bl_id = 1337; name = "God"; });
	BrickGroup_888888.add(%brick);
}

function servercmdGive(%client, %amount, %material, %to, %name1, %name2, %name3, %name4, %name5, %name6, %name7, %name8, %name9)
{
	//amount
	%amount = mfloor(%amount);
	if(mfloor(%amount) <= 0)
	{
		%client.chatMessage("\c6Please enter a valid number.");
		return;
	}
	
	//material
	%material = getRawMaterialName(%material);
	if(!isRawMaterialName(%material))
	{
		%client.chatMessage("\c6Please enter a valid material.");
		return;
	}
	
	//check if they have enough
	if($EOTW::PlayerData[%client.bl_id, "Material", %material] < %amount)
	{
		%client.chatMessage("\c6You don't have that much " @ getMaterialName(%material) @ ".");
		return;
	}
	
	//blid mode
	if(%name1 $= "BLID" || %name1 $= "BL_ID")
	{
		%blid = %name2;
		%blidmode = true;
	}
	else if(%to $= "BLID" || %to $= "BL_ID")
	{
		%blid = %name1;
		%blidmode = true;
	}
	
	if(%blidmode)
	{
		//check if it's a valid blid
		if(mfloor(%blid) !$= %blid || mfloor(%blid) < 0)
		{
			%client.chatMessage("\c6Please enter a valid BL_ID.");
			return;
		}
		
		%to = findclientbybl_id(%blid);
		
		//check if they exist
		if(!isObject(%to))
		{
			%client.chatMessage("\c6Nobody with that BL_ID is in the server.");
			return;
		}
		
		//if they get to this point, then %to should exist
	}
	else
	{
		//name mode
		%name = %name1 SPC %name2 SPC %name3 SPC %name4 SPC %name5 SPC %name6 SPC %name7 SPC %name8 SPC %name9;
		if(%to !$= "to")
			%name = %to SPC %name;
		
		%name = trim(%name);
		%to = findclientbyname(%name);
		
		//add "to" to their name if they don't exist, just in case the first word of their name ACTUALLY is "to"
		if(!isObject(%to))
			%name = "to" SPC %name;
		
		//check if they exist
		if(!isObject(%to))
		{
			%client.chatMessage("\c6Nobody with that name is in the server.");
			return;
		}
		
		//if they get to this point, then %to should exist
	}
	
	if(isObject(%to))
	{
		//check if they're giving it to themself
		if(%to == %client)
		{
			%client.chatMessage("\c6You can't give materials to yourself.");
			return;
		}
		
		//check if they have confirmed the transation
		if(%client.giveConfirmAmount != %amount)
			%misMatch = true;
		if(%client.giveConfirmMaterial !$= %material)
			%misMatch = true;
		if(%client.giveConfirmName !$= %to.getPlayerName())
			%misMatch = true;
		if(%client.giveConfirmBL_ID != %to.BL_ID)
			%misMatch = true;
		
		if(%misMatch)
		{
			%client.giveConfirmAmount = %amount;
			%client.giveConfirmMaterial = %material;
			%client.giveConfirmName = %to.getPlayerName();
			%client.giveConfirmBL_ID = %to.BL_ID;
			
			%client.chatMessage("\c6Are you sure you want to give " @ %client.giveConfirmAmount SPC getMaterialName(%client.giveConfirmMaterial) @ " to " @ %client.giveConfirmName @ " whose BL_ID is " @ %client.giveConfirmBL_ID @ "?");
			%client.chatMessage("\c6Repeat the command to confirm.");
			return;
		}
		
		//give the stuff
		%client.addMaterial(%amount * -1, %material, "\c2+1 Metal Pick", "\c7to " @ %to.getPlayerName());
		%to.addMaterial(%amount, %material, "\c7from " @ %client.getPlayerName());
		
		%client.chatMessage("\c6You have given " @ %to.getPlayerName() SPC %amount SPC getMaterialName(%material) @ ".");
		%to.chatMessage("\c6" @ %client.getPlayerName() @ " has given you " @ %amount SPC getMaterialName(%material) @ ".");
		
		%client.giveConfirmAmount = "";
		%client.giveConfirmMaterial = "";
		%client.giveConfirmName = "";
		%client.giveConfirmBL_ID = "";
	}
	else
		error("ERROR: " @ %client @ " tried giving materials to " @ %to @ ", who doesn't exist");
}

function GameConnection::addMaterial(%client, %amount, %material, %message)
{
	if(!isObject(%client))
		return;
	
	%amount = mfloor(%amount);
	if(%amount == 0)
		return;
	
	%material = getRawMaterialName(%material);
	if(!isRawMaterialName(%material))
	{
		error("ERROR: Tried to give " @ %client @ " invalid material \"" @ %material @ "\"");
		return;
	}
	
	$EOTW::PlayerData[%client.bl_id, "Material", %material] += %amount;
	export("$EOTW::PlayerData" @ %client.bl_id @ "_*", "config/server/SolarApoc/playersaves/" @ %client.bl_id @ ".cs");
	
	if(getSimTime() - %client.lastAddMaterialTime > 1000 || %client.lastAddMaterialType !$= %material || %client.lastAddMaterialMessage !$= %message)
		%client.lastAddMaterialAmount = %amount;
	else
		%client.lastAddMaterialAmount += %amount;
	
	%client.lastAddMaterialType = %material;
	%client.lastAddMaterialMessage = %message;
	%client.lastAddMaterialTime = getSimTime();
	
	if(%client.lastAddMaterialAmount > 0)
		%prefix = "\c2+";
	if(%client.lastAddMaterialAmount < 0)
		%prefix = "\c0";
	
	if(%client.lastAddMaterialAmount == 0)
		%client.centerPrint("", 1);
	else
		%client.centerPrint("<just:right>" @ %prefix @ %client.lastAddMaterialAmount SPC getMaterialName(%material) @ " <br>\c6" @ %client.lastAddMaterialMessage @ " ", 1);
	
	%client.showEOTWHud();
}

function getMaterialName(%material)
{
	if(%material $= "Dead_Plant") //impossible, but just in case
		return "Dead_Plant";
	if(%material $= "Charcoal") //impossible, but just in case
		return "Charcoal";
	if(%material $= "Glass")
		return "Glass";
	if(%material $= "Grass") //impossible, but just in case
		return "Grass";
	if(%material $= "Metal")
		return "Metal";
	if(%material $= "Stone")
		return "Stone";
	if(%material $= "Vine")
		return "Vine";
	if(%material $= "Wood")
		return "Wood";
	if(isSturdiumName(%material))
		return $EOTW::SaveData::SturdiumName;
}

function getRawMaterialName(%material)
{
	if(%material $= "Dead_Plant") //impossible, but just in case
		return "Dead_Plant";
	if(%material $= "Charcoal") //impossible, but just in case
		return "Charcoal";
	if(%material $= "Glass")
		return "Glass";
	if(%material $= "Grass") //impossible, but just in case
		return "Grass";
	if(%material $= "Metal")
		return "Metal";
	if(%material $= "Stone")
		return "Stone";
	if(%material $= "Vine")
		return "Vine";
	if(%material $= "Wood")
		return "Wood";
	if(isSturdiumName(%material))
		return "Sturdium";
}

function getSturdiumName()
{
	%names = 0;
	%name[%names++] = "Sturdium";
	%name[%names++] = "Adminium";
	%name[%names++] = "Eternium";
	
	if(%names >= 1)
		return %name[getRandom(1, %names)];
	else
		return "Error";
}

function isSturdiumName(%material)
{
	if(%material $= "???"
	|| %material $= "Sturdium"
	|| %material $= "Adminium"
	|| %material $= "Eternium"
	|| %material $= "Error")
		return true;
	
	return false;
}

function isMaterialName(%material)
{
	if(%material $= "Dead_Plant" //impossible, but just in case
	|| %material $= "Charcoal" //impossible, but just in case
	|| %material $= "Glass"
	|| %material $= "Grass" //impossible, but just in case
	|| %material $= "Metal"
	|| %material $= "Stone"
	|| %material $= "Vine"
	|| %material $= "Wood"
	|| isSturdiumName(%material))
		return true;
	
	return false;
}

function isRawMaterialName(%material)
{
	if(%material $= "Dead_Plant" //impossible, but just in case
	|| %material $= "Charcoal" //impossible, but just in case
	|| %material $= "Glass"
	|| %material $= "Grass" //impossible, but just in case
	|| %material $= "Metal"
	|| %material $= "Stone"
	|| %material $= "Vine"
	|| %material $= "Wood"
	|| %material $= "Sturdium")
		return true;
	
	return false;
}

function isPlant(%material)
{
	if(%material $= "Dead_Plant" //impossible, but just in case
	|| %material $= "Grass" //impossible, but just in case
	|| %material $= "Vine")
		return true;
	
	return false;
}

//%brick.canBeFireballed   // - - Implement this
//%brick.collectTime (in MS)
//%brick.destroyOnDay   //Collectable spawns only; don't apply this to built bricks
//%brick.forceVolume
//%brick.isBreakable   // - - - - Implement this
//%brick.isCollectable
//%brick.isFlammable   // - - - - Implement this
//%brick.isIgnitable   // - - - - Implement this
//%brick.material
//%brick.smashable   // - - - - - Implement this
//%brick.unrecolorable   // - - - Implement this