if(!$EOTW::hasBeenLoaded)
{
	//default tools
	hammerItem.canDrop = false;
	wrenchItem.canDrop = false;
	printGun.canDrop = false;
	
	//empty
	datablock ItemData(solarApocEmptyItem)
	{
		canDrop = false;
		
		category = "Weapon";
		className = "Weapon";

		iconName = "./shapes/empty_Icon";
		image = solarApocEmptyImage;

		canDrop = false;
	};
	
	datablock ShapeBaseImageData(solarApocEmptyImage)
	{
		className = "WeaponImage";
		shapeFile = "base/data/shapes/empty.dts";
		emap = true;
		mountPoint = 0;
		
		stateName[0]					= "Ready";
		stateTransitionOnTriggerDown[0]	= "Fire";
		stateAllowImageChange[0]		= true;

		stateName[1]					= "Fire";
		stateTransitionOnTimeout[1]		= "Ready";
		stateAllowImageChange[1]		= true;
		stateScript[1]					= "onFire";
		stateTimeoutValue[1]			= 1;
	};
	
	datablock ShapeBaseImageData(solarApocToolTutorialImage)
	{
		className = "WeaponImage";
		shapeFile = "base/data/shapes/empty.dts";
		emap = true;
		mountPoint = 0;
		
		stateName[0]					= "Ready";
		stateTransitionOnTriggerDown[0]	= "Fire";
		stateAllowImageChange[0]		= true;

		stateName[1]					= "Fire";
		stateTransitionOnTimeout[1]		= "Ready";
		stateAllowImageChange[1]		= true;
		stateScript[1]					= "onFire";
		stateTimeoutValue[1]			= 1;
	};
	
	//hands
	datablock ShapeBaseImageData(solarApocToolHandsImage)
	{
		className = "SolarApocToolImage";
		shapeFile = "base/data/shapes/empty.dts";
		emap = true;
		mountPoint = 1;
		offset = "-0.008 0.01 -0.13";
		item = "";
		
		isSolarApocTool = true;
		displayName = "Hands";
		collectPower = 16;
		fakeItem = solarApocEmptyItem;

		armReady = true;
		
		eyeOffset = "0.7 1.4 -0.8";
		eyeOffset = "";
		rotation = "0 0 0 180";
		eyeRotation = "0 0 0 0";
		
		stateName[0] = "Ready";
	};

	//stone
	datablock ShapeBaseImageData(solarApocToolStoneImage : solarApocToolHandsImage)
	{
		shapeFile = "./shapes/pick.dts";
		
		displayName = "Stone Pick";
		collectPower = 32;
		fakeItem = solarApocToolStoneItem;
		
		colorShiftColor = "0.75 0.75 0.80 1.00";
	};
	
	datablock ItemData(solarApocToolStoneItem)
	{
		category = "Weapon";
		className = "Weapon";

		uiName = solarApocToolStoneImage.displayName;
		iconName = "./shapes/stonePick_Icon";
		
		image = solarApocToolTutorialImage;

		canDrop = false;
	};

	//metal
	datablock ShapeBaseImageData(solarApocToolMetalImage : solarApocToolStoneImage)
	{
		displayName = "Metal Pick";
		collectPower = 64;
		fakeItem = solarApocToolMetalItem;

		colorShiftColor = "0.35 0.35 0.40 1.00";
	};
	
	datablock ItemData(solarApocToolMetalItem : solarApocToolStoneItem)
	{
		uiName = solarApocToolMetalImage.displayName;
		iconName = "./shapes/metalPick_Icon";
	};

	//sturdium
	datablock ShapeBaseImageData(solarApocToolSturdiumImage : solarApocToolMetalImage)
	{
		displayName = "??? Pick"; //dynamically changes
		collectPower = 128;
		fakeItem = solarApocToolSturdiumItem;

		colorShiftColor = "0.20 0.20 0.25 1.00";
	};
	
	datablock ItemData(solarApocToolSturdiumItem : solarApocToolMetalItem)
	{
		uiName = solarApocToolSturdiumImage.displayName;
		iconName = "./shapes/sturdiumPick_Icon";
	};
	
	//health pill
	datablock ItemData(solarApocHealthPillItem)
	{
		category = "Weapon";
		className = "Weapon";
		
		uiName = "Health Pill";
		iconName = "./shapes/pill_Icon";

		image = solarApocHealthPillImage;
		canDrop = false;
	};

	datablock ShapeBaseImageData(solarApocHealthPillImage)
	{
		shapeFile = "./shapes/pill.dts";
		emap = true;

		mountPoint = 0;
		offset = "0.09 -0.07 -0.2";
		eyeOffset = 0;
		rotation = eulerToMatrix( "0 0 0" );

		className = "SolarApocPillImage";
		item = solarApocHealthPillItem;

		armReady = true;

		doColorShift = true;
		colorShiftColor = "1 0 0 1";

		healPower = 5;
		healTicks = 10; //5 ticks per second
		healEmote = HealImage;

		stateName[0]					= "Ready";
		stateTransitionOnTriggerDown[0]	= "Fire";
		stateAllowImageChange[0]		= true;

		stateName[1]					= "Fire";
		stateTransitionOnTimeout[1]		= "Ready";
		stateAllowImageChange[1]		= true;
		stateScript[1]					= "onFire";
		stateTimeoutValue[1]			= 1;
	};
	
	datablock ParticleData(HealParticle)
	{
		dragCoefficient      = 5.0;
		gravityCoefficient   = -0.2;
		inheritedVelFactor   = 0.0;
		constantAcceleration = 0.0;
		lifetimeMS           = 1000;
		lifetimeVarianceMS   = 500;
		useInvAlpha          = false;
		textureName          = "./shapes/heal";
		colors[0]     = "1.0 1.0 1.0 1";
		colors[1]     = "1.0 1.0 1.0 1";
		colors[2]     = "0.0 0.0 0.0 0";
		sizes[0]      = 0.4;
		sizes[1]      = 0.6;
		sizes[2]      = 0.4;
		times[0]      = 0.0;
		times[1]      = 0.2;
		times[2]      = 1.0;
	};

	datablock ParticleEmitterData(HealEmitter)
	{
		ejectionPeriodMS = 35;
		periodVarianceMS = 0;
		ejectionVelocity = 0.5;
		ejectionOffset   = 1.0;
		velocityVariance = 0.49;
		thetaMin         = 0;
		thetaMax         = 120;
		phiReferenceVel  = 0;
		phiVariance      = 360;
		overrideAdvance = false;
		particles = "HealParticle";

		uiName = "Emote - Heal";
	};

	datablock ShapeBaseImageData(HealImage)
	{
		shapeFile = "base/data/shapes/empty.dts";
		emap = false;

		mountPoint = $HeadSlot;

		stateName[0]					= "Ready";
		stateTransitionOnTimeout[0]		= "FireA";
		stateTimeoutValue[0]			= 0.01;

		stateName[1]					= "FireA";
		stateTransitionOnTimeout[1]		= "Done";
		stateWaitForTimeout[1]			= true;
		stateTimeoutValue[1]			= 0.350;
		stateEmitter[1]					= HealEmitter;
		stateEmitterTime[1]				= 0.350;

		stateName[2]					= "Done";
		stateScript[2]					= "onDone";
	};
	
	//super health pill
	datablock ItemData(solarApocSuperHealthPillItem : solarApocHealthPillItem)
	{
		uiName = "Super Pill";
		iconName = "./shapes/superPill_Icon";

		image = solarApocSuperHealthPillImage;
	};

	datablock ShapeBaseImageData(solarApocSuperHealthPillImage : solarApocHealthPillImage)
	{
		item = solarApocSuperHealthPillItem;

		colorShiftColor = "0 1 0 1";
		
		healPower = 10;
		healTicks = 20; //5 ticks per second
		healEmote = SuperHealImage;
	};
	
	datablock ParticleData(SuperHealParticle : HealParticle)
	{
		textureName = "./shapes/superHeal";
	};

	datablock ParticleEmitterData(SuperHealEmitter : HealEmitter)
	{
		particles = "SuperHealParticle";

		uiName = "Emote - Super Heal";
	};

	datablock ShapeBaseImageData(SuperHealImage : HealImage)
	{
		stateEmitter[1] = SuperHealEmitter;
	};
}

//empty
function solarApocEmptyImage::onFire(%datablock,%player,%slot)
{
	return;
}

//tools
function solarApocToolTutorialImage::onFire(%datablock,%player,%slot)
{
	%client = %player.client;
	if(!isObject(%client))
		return;
	
	%client.centerPrint("<just:right>\c6You automatically use your " @ $EOTW::PlayerData[%client.bl_id, "CurrentTool"].displayName @ " when you gather materials.", 5);
}

function SolarApocToolImage::onMount(%datablock,%player,%slot)
{
	if(%image = %player.getMountedImage(0))
	{
		if(%image.armReady)
			%player.playThread(1,armReadyBoth);
		else
			%player.playThread(1,armReadyLeft);
	}
	else
		%player.playThread(1,armReadyLeft);
}

function SolarApocToolImage::unMountCheck(%datablock,%player,%slot)
{
	if(!isObject(%player.getMountedImage(0)))
		%player.playThread(1,armReadyLeft);
}

function SolarApocToolImage::onUnMount(%datablock,%player,%slot)
{
	%player.playThread(1,root);
	%player.lastToolSwingTime = "";
}

//pills
function HealImage::onDone(%this,%obj,%slot)
{
	%obj.unMountImage(%slot);
}
function SuperHealImage::onDone(%this,%obj,%slot)
{
	%obj.unMountImage(%slot);
}

function SolarApocPillImage::onMount(%datablock,%obj,%slot)
{
	%client = %obj.client;
	if(!isObject(%client))
		return;
	
	%client.centerPrint("<just:right>\c6You have " @ $EOTW::PlayerData[%client.bl_id, "Pills"] SPC $EOTW::PlayerData[%client.bl_id, "CurrentPill"].uiName @ "s.", 5);
}

function SolarApocPillImage::onFire(%datablock,%obj,%slot)
{
	if(%obj.getDamageLevel() <= 0)
		return;
	if(%obj.isHealing)
		return;
	
	%client = %obj.client;
	if(!isObject(%client))
		return;
	
	$EOTW::PlayerData[%client.bl_id, "Pills"]--;
	%obj.emote(%datablock.HealEmote, 1);
	%client.centerPrint("<just:right>\c6You have " @ $EOTW::PlayerData[%client.bl_id, "Pills"] SPC $EOTW::PlayerData[%client.bl_id, "CurrentPill"].uiName @ "s.", 5);
	
	cancel(%obj.temporaryHPHeal);
	%obj.isHealing = false;
	%obj.temporaryHPHeal = %obj.schedule(10, doHPHeal, %datablock.healPower, %datablock.healTicks);
}

function Player::doHPHeal(%obj, %power, %ticks)
{
	cancel(%obj.temporaryHPHeal);
	if(!isObject(%obj))
		return;
	
	%ticks--;
	%obj.isHealing = true;
	
	if(%ticks >= 0)
	{
		%obj.addHealth(%power);
		%obj.temporaryHPHeal = %obj.schedule(200, doHPHeal, %power, %ticks);
	}
	else
		%obj.isHealing = false;
}

if(isPackage(SolApocToolPackage))
	deactivatePackage(SolApocToolPackage);
package SolApocToolPackage
{
	function player::updateArm(%player,%image)
	{
		%image1 = %player.getMountedImage(1);
		if(!isObject(%image1))
			return parent::updateArm(%player,%image);
		
		if(!%image1.isSolarApocTool)
			return parent::updateArm(%player,%image);
		if(%image1.armReady)
		{
			if(!isObject(%player.getMountedImage(0)))
				%player.playThread(1,armReadyBoth);
		}
	}
	
	function WeaponImage::onUnMount(%datablock,%player,%slot)
	{
		if(%slot != 0)
			return parent::onUnMount(%datablock,%player,%slot);
		if(!%leftimage = %player.getMountedImage(1))
			return parent::onUnMount(%datablock,%player,%slot);
		if(!%datablock.isSolarApocTool)
			return parent::onUnMount(%datablock,%player,%slot);
		%leftimage.schedule(1,unMountCheck,%player,%slot);
		if(%datablock.showBricks)
		{
			if(isObject(%client = %player.client))
				commandToClient(%client,'ShowBricks',0);
		}
	}
	
	function player::hideNode(%player,%node)
	{
		if(%node $= "lhook" || %node $= "lhand")
		{
			%image = %player.getMountedImage(1);
			if(isObject(%image))
			{
				if(%image.isSolarApocTool)
					%player.unmountSolApocTool();
			}
		}
		parent::hideNode(%player,%node);
	}
};
activatePackage(SolApocToolPackage);

function Player::unmountSolApocTool(%player)
{
	%image = %player.getMountedImage(1);
	if(isObject(%image))
	{
		if(%image.isSolarApocTool)
			%player.unMountImage(1);
	}
}

function servercmdCraft(%client, %arg1, %arg2, %arg3)
{
	%full = %arg1 SPC %arg2 SPC %arg3;
	%full = trim(%full);
	
	if(%full $= "")
	{
		%client.chatMessage("\c6Crafting recipes:");
		
		if($EOTW::PlayerData[%client.bl_id, "CurrentTool"] $= "solarApocToolStoneImage"
		|| $EOTW::PlayerData[%client.bl_id, "CurrentTool"] $= "solarApocToolMetalImage"
		|| $EOTW::PlayerData[%client.bl_id, "CurrentTool"] $= "solarApocToolSturdiumImage")
			%client.chatMessage("\c2 - Stone Pick \c7- 1000 Stone");
		else if($EOTW::PlayerData[%client.bl_id, "Material", "Stone"] >= 1000)
			%client.chatMessage("\c3 - Stone Pick \c7- 1000 Stone");
		else
			%client.chatMessage("\c0 - Stone Pick \c7- 1000 Stone");
		
		if($EOTW::PlayerData[%client.bl_id, "CurrentTool"] $= "solarApocToolMetalImage"
		|| $EOTW::PlayerData[%client.bl_id, "CurrentTool"] $= "solarApocToolSturdiumImage")
			%client.chatMessage("\c2 - Metal Pick \c7- 1000 Metal");
		else if($EOTW::PlayerData[%client.bl_id, "Material", "Metal"] >= 1000)
			%client.chatMessage("\c3 - Metal Pick \c7- 1000 Metal");
		else
			%client.chatMessage("\c0 - Metal Pick \c7- 1000 Metal");
		
		if($EOTW::PlayerData[%client.bl_id, "Material", "Sturdium"] > 0)
		{
			if($EOTW::PlayerData[%client.bl_id, "CurrentTool"] $= "solarApocToolSturdiumImage")
				%client.chatMessage("\c2 - " @ $EOTW::SaveData::SturdiumName @ " Pick \c7- 1000 " @ $EOTW::SaveData::SturdiumName);
			else if($EOTW::PlayerData[%client.bl_id, "Material", "Sturdium"] >= 1000)
				%client.chatMessage("\c3 - " @ $EOTW::SaveData::SturdiumName @ " Pick \c7- 1000 " @ $EOTW::SaveData::SturdiumName);
			else
				%client.chatMessage("\c0 - " @ $EOTW::SaveData::SturdiumName @ " Pick \c7- 1000 " @ $EOTW::SaveData::SturdiumName);
		}
		
		if($EOTW::PlayerData[%client.bl_id, "CurrentPill"] $= "solarApocEmptyItem")
			%client.chatMessage("\c0 - Health Pill \c7- 100 Vine - Requires Medical");
		else
		{
			if($EOTW::PlayerData[%client.bl_id, "Material", "Vine"] < 100)
				%client.chatMessage("\c0 - " @ $EOTW::PlayerData[%client.bl_id, "CurrentPill"].uiname @ " \c7- 100 Vine");
			else
				%client.chatMessage("\c3 - " @ $EOTW::PlayerData[%client.bl_id, "CurrentPill"].uiname @ " \c7- 100 Vine");
		}
		
		%client.chatMessage("\c2Green \c6denotes things that would be redundant to craft.");
		%client.chatMessage("\c3Yellow \c6denotes things you are able to craft at this moment.");
		%client.chatMessage("\c0Red \c6denotes things you are unable to craft with your current knowledge and materials.");
		
		return;
	}
	
	if(%full $= "Stone Pick")
	{
		//check if they already have it
		if($EOTW::PlayerData[%client.bl_id, "CurrentTool"] $= "solarApocToolStoneImage")
		{
			%client.chatMessage("\c6You already have a Stone Pick.");
			return;
		}
		
		//check if they already have a better tool
		if($EOTW::PlayerData[%client.bl_id, "CurrentTool"] $= "solarApocToolStoneImage"
		|| $EOTW::PlayerData[%client.bl_id, "CurrentTool"] $= "solarApocToolMetalImage"
		|| $EOTW::PlayerData[%client.bl_id, "CurrentTool"] $= "solarApocToolSturdiumImage")
		{
			%client.chatMessage("\c6You already have a better pick.");
			return;
		}
		
		//check if they have enough
		if($EOTW::PlayerData[%client.bl_id, "Material", "Stone"] < 1000)
		{
			%client.chatMessage("\c6You need 1000 Stone to make a Stone Pick.");
			return;
		}
		
		%client.addMaterial(-1000, "Stone", "\c2+1 Stone Pick");
		$EOTW::PlayerData[%client.bl_id, "CurrentTool"] = "solarApocToolStoneImage";
		%client.chatMessage("\c6You have crafted a Stone Pick using 1000 Stone.");
		return;
	}
	if(%full $= "Metal Pick")
	{
		//check if they already have it
		if($EOTW::PlayerData[%client.bl_id, "CurrentTool"] $= "solarApocToolMetalImage")
		{
			%client.chatMessage("\c6You already have a Metal Pick.");
			return;
		}
		
		//check if they already have a better tool
		if($EOTW::PlayerData[%client.bl_id, "CurrentTool"] $= "solarApocToolSturdiumImage")
		{
			%client.chatMessage("\c6You already have a better pick.");
			return;
		}
		
		//check if they have enough
		if($EOTW::PlayerData[%client.bl_id, "Material", "Metal"] < 1000)
		{
			%client.chatMessage("\c6You need 1000 Metal to make a Metal Pick.");
			return;
		}
		
		%client.addMaterial(-1000, "Metal", "\c2+1 Metal Pick");
		$EOTW::PlayerData[%client.bl_id, "CurrentTool"] = "solarApocToolMetalImage";
		%client.chatMessage("\c6You have crafted a Metal Pick using 1000 Metal.");
		return;
	}
	if(isSturdiumName(%arg1) && %arg2 $= "Pick")
	{
		//check if they already have it
		if($EOTW::PlayerData[%client.bl_id, "CurrentTool"] $= "solarApocToolSturdiumImage")
		{
			%client.chatMessage("\c6You already have a " @ $EOTW::SaveData::SturdiumName @ " Pick.");
			return;
		}
		
		//check if they have enough
		if($EOTW::PlayerData[%client.bl_id, "Material", "Sturdium"] < 1000)
		{
			%client.chatMessage("\c6You need 1000 " @ $EOTW::SaveData::SturdiumName @ " to make a " @ $EOTW::SaveData::SturdiumName @ " Pick.");
			return;
		}
		
		%client.addMaterial(-1000, "Sturdium", "\c2+1 " @ $EOTW::SaveData::SturdiumName @ " Pick");
		$EOTW::PlayerData[%client.bl_id, "CurrentTool"] = "solarApocToolSturdiumImage";
		%client.chatMessage("\c6You have crafted a " @ $EOTW::SaveData::SturdiumName @ " Pick using 1000 " @ $EOTW::SaveData::SturdiumName @ ".");
		return;
	}
	if(%arg1 $= "Pill" || %arg2 $= "Pill" || %arg3 $= "Pill")
	{
		//check if they dont have any pills researched
		if($EOTW::PlayerData[%client.bl_id, "CurrentPill"] $= "solarApocEmptyItem")
		{
			%client.chatMessage("\c6You need to research Medical first.");
			return;
		}
		
		%pillName = $EOTW::PlayerData[%client.bl_id, "CurrentPill"].uiname;
		
		//check if they have enough
		if($EOTW::PlayerData[%client.bl_id, "Material", "Vine"] < 100)
		{
			%client.chatMessage("\c6You need 100 Vine to make a " @ %pillName @ ".");
			return;
		}
		
		%client.addMaterial(-100, "Vine", "\c2+1 " @ %pillName);
		$EOTW::PlayerData[%client.bl_id, "Pills"]++;
		%client.chatMessage("\c6You have crafted a " @ %pillName @ " using 100 Vine.");
		return;
	}
	
	%client.chatMessage("\c6Invalid object.");
}

function servercmdResearch(%client, %arg1, %arg2)
{
	%full = %arg1 SPC %arg2 SPC %arg3;
	%full = trim(%full);
	
	if(%full $= "")
	{
		%client.chatMessage("\c6Research goals:");
		
		if($EOTW::PlayerData[%client.bl_id, "ResearchedMedical"])
			%client.chatMessage("\c2 - Medical");
		else
			%client.chatMessage("\c3 - Medical");
		
		if($EOTW::PlayerData[%client.bl_id, "ResearchedAdvancedMedical"])
			%client.chatMessage("\c2 - Advanced Medical");
		else if($EOTW::PlayerData[%client.bl_id, "ResearchedMedical"])
			%client.chatMessage("\c3 - Advanced Medical");
		else
			%client.chatMessage("\c0 - Advanced Medical");

		%client.chatMessage("\c2Green \c6denotes things you have already researched.");
		%client.chatMessage("\c3Yellow \c6denotes things you are able to research right away.");
		%client.chatMessage("\c0Red \c6denotes things you are unable to research due to not having reached previous goals.");
		
		return;
	}
	
	if(%full $= "Medical")
	{
		//check if they already researched it
		if($EOTW::PlayerData[%client.bl_id, "ResearchedMedical"])
		{
			%client.chatMessage("\c6You have already researched Medical.");
			return;
		}
		
		//check if they are researching something
		if($EOTW::PlayerData[%client.bl_id, "Researching"] !$= "")
		{
			%client.chatMessage("\c6You are already researching " @ $EOTW::PlayerData[%client.bl_id, "Researching"] @ ". You will complete it in " @ $EOTW::PlayerData[%client.bl_id, "ResearchDaysLeft"] @ " days.");
			return;
		}
		
		$EOTW::PlayerData[%client.bl_id, "ResearchDaysLeft"] = 3;
		$EOTW::PlayerData[%client.bl_id, "Researching"] = "Medical";
		$EOTW::PlayerData[%client.bl_id, "ResearchingMessage"] = "You can now craft Health Pills!";
		%client.chatMessage("\c6You have started researching Medical. You will complete your research in " @ $EOTW::PlayerData[%client.bl_id, "ResearchDaysLeft"] @ " days");
		return;
	}
	if(%full $= "Advanced Medical")
	{
		//check if they already researched it
		if($EOTW::PlayerData[%client.bl_id, "ResearchedAdvancedMedical"])
		{
			%client.chatMessage("\c6You have already researched Advanced Medical.");
			return;
		}
		
		//check if they are researching something
		if($EOTW::PlayerData[%client.bl_id, "Researching"] !$= "")
		{
			%client.chatMessage("\c6You are already researching " @ $EOTW::PlayerData[%client.bl_id, "Researching"] @ ". You will complete it in " @ $EOTW::PlayerData[%client.bl_id, "ResearchDaysLeft"] @ " days.");
			return;
		}
		
		$EOTW::PlayerData[%client.bl_id, "ResearchDaysLeft"] = 5;
		$EOTW::PlayerData[%client.bl_id, "Researching"] = "Advanced Medical";
		$EOTW::PlayerData[%client.bl_id, "ResearchingMessage"] = "You can now craft Super Pills!";
		%client.chatMessage("\c6You have started researching Advanced Medical. You will complete your research in " @ $EOTW::PlayerData[%client.bl_id, "ResearchDaysLeft"] @ " days");
		return;
	}
	
	%client.chatMessage("\c6Invalid research.");
}